define("local_webshell/shell",["exports","core/ajax"],(function(_exports,_ajax){var obj;
/**
   * Shell Component.
   *
   * @module     local_webshell/shell
   * @class      local_webshell/shell
   * @copyright  2024 Vincent Schneider (cli-ish)
   * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
   */Object.defineProperty(_exports,"__esModule",{value:!0}),_exports.default=void 0,_ajax=(obj=_ajax)&&obj.__esModule?obj:{default:obj};class Component{constructor(){this.history=this._fetchHistory(),this.selectionArrow=this.history.length,this.resultbox=document.querySelector("body .local_webshell .shell-result"),this.inputbox=document.querySelector("body .local_webshell .shell-input"),this.stateReady()}static init(){return new Component}_updateUi(result){this.inputbox.querySelector(".username").innerText=result.user,this.inputbox.querySelector(".workingdir").innerText=result.workingdir}_printResult(command,result){const cmdNode=document.createElement("div");cmdNode.innerHTML='<div class="cmdline"><span class="username">'+result.user+':</span><span class="workingdir">'+result.workingdir+'</span><span class="arg">#</span> '+command+"</div>",this.resultbox.appendChild(cmdNode);const resultNode=document.createElement("div");resultNode.textContent+=atob(result.result),this.resultbox.appendChild(resultNode),this.resultbox.scrollTop=this.resultbox.scrollHeight}_execCommand(command,callback){_ajax.default.call([{methodname:"local_webshell_run",args:{command:command}}])[0].done((function(response){callback(response)}))}_hinting(value,type,callback){_ajax.default.call([{methodname:"local_webshell_hinting",args:{value:value,type:type}}])[0].done((function(response){callback(response)}))}stateReady(){let that=this;this.inputbox.querySelector("#shell-cmd").addEventListener("keydown",(e=>{let command="";switch(event.key){case"Enter":if(command=e.target.value,e.target.value="","clear"===command)return void(that.resultbox.innerHTML="");this._pushToHistory(command),this.selectionArrow=this.history.length,that._execCommand(command,(data=>{that._printResult(command,data),that._updateUi(data)}));break;case"ArrowUp":if(e.preventDefault(),that.selectionArrow-1<0)return;that.selectionArrow-=1,that.inputbox.querySelector("#shell-cmd").value=that.history[that.selectionArrow];break;case"ArrowDown":if(e.preventDefault(),that.selectionArrow+1>=that.history.length)return that.selectionArrow=that.history.length,void(that.inputbox.querySelector("#shell-cmd").value="");that.selectionArrow+=1,that.inputbox.querySelector("#shell-cmd").value=that.history[that.selectionArrow];break;case"Tab":e.preventDefault(),that._autocomplete(e.target)}}))}_fetchHistory(){let result=window.localStorage.getItem("moodle-local_webshell/history");if(null===result)return[];let data=JSON.parse(result);return Array.isArray(data)?data:[]}_pushToHistory(command){this.history.push(command),window.localStorage.setItem("moodle-local_webshell/history",JSON.stringify(this.history))}_autocomplete(target){let command=target.value;if(0===command.trim().length)return;let parts=command.split(" "),type=1===parts.length?"binary":"file",value="binary"===type?parts[0]:parts[parts.length-1],resultStr="",that=this;this._hinting(value,type,(result=>{if(!(result.matches.length<=0))if(1===result.matches.length)target.value="binary"===type?result.matches[0]:command.replace(/(\S*)$/,result.matches[0]);else{resultStr="";let count=0;result.matches.forEach((entry=>{resultStr+=entry+"\t",count>5&&(count=0,resultStr+="\n"),count++})),result.result=btoa(resultStr),that._printResult(command,result)}}))}}return _exports.default=Component,_exports.default}));

//# sourceMappingURL=shell.min.js.map